/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 182 by dpavlin, Tue Mar 16 17:46:32 2010 UTC revision 271 by dpavlin, Fri Sep 9 18:21:14 2011 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /bin/sh
2    ### BEGIN INIT INFO
3    # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15  # lxc-watchdog.sh  # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
 #  
 # Dobrica Pavlinusic <dpavlin@rot13.org> 2010-03-15  
 #  
 # this script can be used to start/stop Linux containers  
 # using clever inotify hack to monitor halt/reboot from  
 # Tony Risinger posted to lxc-users mailing list  
16  #  #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 lxc_status() {  
         lxc-ls -1 | sort -u | xargs -i lxc-info -n {}  
 }  
27    
28  lxc_exists() {  lxc_exists() {
29          name=$1          name=$1
# Line 29  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56    lxc_status() {
57            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                    status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`
59                    boot="-"
60                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
61                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
62            done ) | column -t
63  }  }
64    
65    
# Line 37  cleanup_init_scripts() { Line 67  cleanup_init_scripts() {
67          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
68    
69          ls \          ls \
70                    $rootfs/etc/rc?.d/*checkroot* \
71                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
72                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
73                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
74                    $rootfs/etc/rc?.d/*udev* \
75                    $rootfs/etc/rc?.d/*checkfs* \
76          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
77    
78            echo $1 > $rootfs/etc/hostname
79            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
80  }  }
81    
82    
83  setup_inittab() {  setup_inittab() {
84          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
85            remove=$2
86            add=$3
87    
88          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
89          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
90          powerfail="pw::powerfail:/sbin/init 0"          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
91          if ! grep "$powerfail" ${inittab} >/dev/null ; then                  grep -v "$remove" ${inittab} > ${inittab}.new
92                  grep -v ::power ${inittab} > ${inittab}.new                  echo $add >> ${inittab}.new
                 echo $powerfail >> ${inittab}.new  
93                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
94                  echo "$initab modified"                  echo "$inittab modified with $add"
95          fi          fi
96    }
97    
98    
99    lxc_log() {
100            echo `date +%Y-%m-%dT%H:%M:%S` $*
101  }  }
102    
103    
104  lxc_stop() {  lxc_kill() {
105          name=$1          name=$1
106            sig=$2
107    
108          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
109          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
110                  lxc-info -n $name                  lxc-info -n $name
111                  exit 1                  exit 1
112          fi          fi
113          echo "$name stop $init_pid"          lxc_log "$name kill $sig $init_pid"
114          /bin/kill -SIGPWR $init_pid          /bin/kill $sig $init_pid
115          lxc-wait -n $name -s STOPPED  }
116    
117    lxc_stop() {
118            lxc_log "$name stop"
119            lxc_kill $name -SIGPWR
120            lxc-wait -n $name -s STOPPED
121            lxc_log "$name stoped"
122    #       rm -f /var/lib/lxc/${name}/on_boot
123  }  }
124    
125    
126  lxc_start() {  lxc_start() {
127          name=$1          name=$1
128            rootfs=$(lxc_rootfs $1)
129    
130            if [ ! -e $rootfs ] ; then
131                    echo "ERROR $name rootfs $rootfs not found"
132                    return
133            fi
134    
135          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
136                  echo "$name start"                  lxc_log "$name start"
137                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
138                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
139                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
140                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
141                  lxc-info  -n $name                  lxc-info  -n $name
142                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
143          fi          fi
144  }  }
145    
146  lxc_watchdog() {  lxc_watchdog() {
147  name=$1  name=$1
148  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
149    run=$rootfs/var/run
150    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
151    cd $run || echo "can't cd watchdog into $run"
152    
153  while true; do  while true; do
         vps_utmp=${rootfs}/var/run/utmp  
154          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
155            stop_on=1 # init
156            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
157            if [ "$sulogins" -gt 0 ] ; then
158                    stop_on=`expr $stop_on + $sulogins`
159            fi
160    
161          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
162          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
163    
164                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
165                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
166    
167                  case $runlevel in                  case $runlevel in
168                  N*)                  N*)
169                          # nothing for new boot state                          # nothing for new boot state
170                  ;;                  ;;
171                  ??0)                  ??0|unknown)
172                          echo "$name halt"                          lxc_log "$name halt"
173                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
174                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
175                          break                          break
176                  ;;                  ;;
177                  ??6)                  ??6)
178                          echo "$name reboot";                          lxc_log "$name reboot";
179                          lxc-stop -n ${name}                          lxc-stop -n ${name}
180                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
181                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 122  while true; do Line 187  while true; do
187                  ;;                  ;;
188                  esac                  esac
189          else          else
190                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
191          fi          fi
192    
193          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
194          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
195  done  done
196    
197  echo "${name} exited"  lxc_log "$name watchdog exited"
198    
199    }
200    
201    
202    usage() {
203            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
204            exit 3
205  }  }
206    
207    command_on_lxc() {
208    command=$1
209    shift
210    
211  case "$1" in  echo "# $command $1"
212    
213    case "$command" in
214    
215  start)  start)
216          lxc_exists $2          lxc_exists $1
217          cleanup_init_scripts $2          cleanup_init_scripts $1
218          setup_inittab $2          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
219          lxc_start $2          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
220          ( nohup $0 watchdog $2 >> /tmp/$2.log ) &          setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
221          ;;          lxc_start $1
222  stop)          # give container 5 seconds to start more than one process
223          lxc_exists $2          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
224          lxc_stop $2          ;;
225          ;;  stop|halt)
226  status)          lxc_exists $1
227          lxc_status          lxc_stop $1
228          ;;          ;;
229  reload|force-reload|restart)  reload|force-reload|restart|reboot)
230          lxc_stop $2          lxc_kill $1 -SIGINT
         lxc_start $2  
231          ;;          ;;
232  watchdog)  watchdog)
233          lxc_watchdog $2          lxc_watchdog $1
234            ;;
235    boot)
236            echo $1 > /var/lib/lxc/$1/on_boot
237            ;;
238    disable)
239            echo -n > /var/lib/lxc/$1/on_boot
240          ;;          ;;
241  *)  *)
242          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
243          ;;          ;;
244    
245  esac  esac
246    
247    }
248    
249    command=$1
250    test -z "$command" && usage
251    test "$command" = "status" && lxc_status && exit
252    shift
253    
254    if [ -z "$1" ] ; then
255            ls /var/lib/lxc/*/on_boot | while read path ; do
256                    name=`echo $path | cut -d/ -f5`
257                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
258                            command_on_lxc $command $name
259                    else
260                            echo "# skip $command $name"
261                    fi
262            done
263    else
264            while [ ! -z "$1" ] ; do
265                    command_on_lxc $command $1
266                    shift
267            done
268    fi
269    

Legend:
Removed from v.182  
changed lines
  Added in v.271

  ViewVC Help
Powered by ViewVC 1.1.26